﻿using MySqlX.Serialization;
using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Mysqlx.Crud.UpdateOperation.Types;

namespace DataManager
{

    public class CollectionTask
    {

        private int userId; // 当前用户，注意：TA未必是任务所分配的用户
        private int taskId;
        private string providerId;
        private string providerName;
        private DateTime taskDate;
        private short taskType;
        private string entityId;
        private string entityName;
        private string errMessage;
        private sbyte isvalid;
        private int? creatorId;
        private string creatorName;
        private DateTime? createTime;
        private int? updatorId;
        private string updaterName;
        private DateTime? updateTime;


        public CollectionTask() { }

        public CollectionTask(int userId, int taskId, string providerId, string providerName, DateTime taskDate, short taskType, 
                              string entityId, string entityName,
                              string errMessage, sbyte isvalid,
                              int? creatorId, string creatorName, DateTime? createTime,
                              int? updatorId, string updaterName, DateTime? updateTime)
        {
            UserId = userId;
            TaskId = taskId;
            ProviderId = providerId;
            ProviderName = providerName;
            TaskDate = taskDate;
            TaskType = taskType;
            EntityId = entityId;
            EntityName = entityName;
            ErrMessage = errMessage;
            Isvalid = isvalid;
            CreatorId = creatorId;
            CreatorName = creatorName;
            CreateTime = createTime;
            UpdatorId = updatorId;
            UpdaterName = updaterName;
            UpdateTime = updateTime;

        }
        public int SaveToSQL(int userId)
        {
            int task_id = 0;

            DataAccess.Set_dm_collection_task(taskId, providerId, taskDate, taskType, entityId, errMessage, isvalid, userId, out task_id);

            return task_id;
        }

        public int UserId { get => userId; set => userId = value; }
        public int TaskId { get => taskId; set => taskId = value; }
        public string ProviderId { get => providerId; set => providerId = value; }
        public string ProviderName { get => providerName; set => providerName = value; }
        public DateTime TaskDate { get => taskDate; set => taskDate = value; }
        public short TaskType { get => taskType; set => taskType = value; }
        public string EntityId { get => entityId; set => entityId = value; }
        public string EntityName { get => entityName; set => entityName = value; }
        public string ErrMessage { get => errMessage; set => errMessage = value; }

        public sbyte Isvalid { get => isvalid; set => isvalid = value; }
        public int? CreatorId { get => creatorId; set => creatorId = value; }
        public string CreatorName { get => creatorName; set => creatorName = value; }
        public DateTime? CreateTime { get => createTime; set => createTime = value; }
        public int? UpdatorId { get => updatorId; set => updatorId = value; }
        public string UpdaterName { get => updaterName; set => updaterName = value; }
        public DateTime? UpdateTime { get => updateTime; set => updateTime = value; }
    }
}
