﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static DataManager.UIConstants;

namespace DataManager
{
    public class ContactTask
    {
        private int userId; // 当前用户，注意：TA未必是任务所分配的用户
        private int taskId;
        private string companyId;
        private string companyShortName;
        private DateTime taskDate;
        private short taskType;
        private sbyte isvalid;
        private sbyte priority;
        private DateTime? followUpDate;
        private sbyte? companyAssetSize;
        private int? creatorId;
        private string creatorName;
        private DateTime? createTime;
        private int? updatorId;
        private string updaterName;
        private DateTime? updateTime;


        public ContactTask()
        {

        }

        public ContactTask(int userId, int taskId, string companyId, string companyShortName, DateTime taskDate, short taskType, sbyte isvalid, sbyte priority,
                           DateTime? followUpDate, sbyte? companyAssetSize, int? creatorId, string creatorName, DateTime? createTime,
                           int? updatorId, string updaterName, DateTime? updateTime)
        {
            UserId = userId;
            TaskId = taskId;
            CompanyId = companyId;
            CompanyShortName = companyShortName;
            TaskDate = taskDate;
            TaskType = taskType;
            Isvalid = isvalid;
            Priority = priority;
            FollowUpDate = followUpDate;
            CompanyAssetSize = companyAssetSize;
            CreatorId = creatorId;
            CreatorName = creatorName;
            CreateTime = createTime;
            UpdatorId = updatorId;
            UpdaterName = updaterName;
            UpdateTime = updateTime;

        }

        public int SaveToSQL(int userId)
        {
            int task_id = 0;
            
            DataAccess.Set_dm_contact_task(taskId, companyId, taskDate, taskType, Isvalid, Priority, FollowUpDate, userId, out task_id);

            return task_id;
        }

        public int UserId { get => userId; set => userId = value; }
        public int TaskId { get => taskId; set => taskId = value; }
        public string CompanyId { get => companyId; set => companyId = value; }
        public string CompanyShortName { get => companyShortName; set => companyShortName = value; }
        public DateTime TaskDate { get => taskDate; set => taskDate = value; }
        public short TaskType { get => taskType; set => taskType = value; }
        public sbyte Isvalid { get => isvalid; set => isvalid = value; }
        public sbyte Priority { get => priority; set => priority = value; }
        public DateTime? FollowUpDate { get => followUpDate; set => followUpDate = value; }
        public sbyte? CompanyAssetSize { get => companyAssetSize; set => companyAssetSize = value; }
        public int? CreatorId { get => creatorId; set => creatorId = value; }
        public string CreatorName { get => creatorName; set => creatorName = value; }
        public DateTime? CreateTime { get => createTime; set => createTime = value; }
        public int? UpdatorId { get => updatorId; set => updatorId = value; }
        public string UpdaterName { get => updaterName; set => updaterName = value; }
        public DateTime? UpdateTime { get => updateTime; set => updateTime = value; }
    }

}
