﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Threading.Tasks;
using System.Collections.ObjectModel;
using System.Windows.Forms;

namespace DataManager
{
    public class UIConstants
    {

        public struct User
        {
            public int UserId;
            public string UserName;
            public int OrgId;
        };
        public static User user;

        public enum JobType
        {
            Contact = 1,
            Collection = 2
        };


        public static readonly Dictionary<int, string> ContactTaskType = new Dictionary<int, string>
        {
            { 1, "建立合作" },
            { 0, "未知"}
        };

        public static readonly Dictionary<int, string> CollectionTaskType = new Dictionary<int, string>
        {
            { 1, "邮件处理" },
            { 2, "文件解析"},
            { 3, "净值校验"},
            { 4, "资产校验"},
            { 5, "新基金"},
            { 6, "净值缺失"},
            { 7, "资产缺失"},
            { 8, "历史净值"},
            { 9, "历史资产"},
            { 0, "未知"}

        };


        public static readonly Dictionary<int, string> TaskPriority = new Dictionary<int, string>
        {
            { 0, "低" },
            { 1, "中" },
            { 2, "高" }
        };

        public static readonly Dictionary<int, string> ContactTaskStatus = new Dictionary<int, string>
        {
            { 0, "删除" },
            { 1, "成功" },
            { 2, "未发送" },
            { 3, "等待回复" },
            { 4, "等待协议" },
            { 5, "拒绝" }
        };


        public static readonly Dictionary<int, string> CollectionTaskStatus = new Dictionary<int, string>
        {
            { 0, "删除" },
            { 1, "解决" },
            { 2, "未处理" },
            { 3, "等待回复" },
            { 4, "忽略" }
        };

        public static readonly Dictionary<int, string> CompanyAssetSize = new Dictionary<int, string>
        {
            { 1, "0-5亿" },
            { 2, "5-10亿" },
            { 3, "10-20亿" },
            { 4, "20-50亿" },
            { 5, "50-100亿" },
            { 6, ">100亿" }
        };

        public static readonly Dictionary<int, string> CompanyOwnerType = new Dictionary<int, string>
        {
            { 1, "中外合作企业" },
            { 2, "中外合资企业" },
            { 3, "内资企业" },
            { 4, "境外机构" },
            { 5, "外商独资企业" },
            { 6, "政府机构" }
        };

        public static readonly Dictionary<int, string> CompanyRegisterStatus = new Dictionary<int, string>
        {
            { 0, "未备案" },
            { 1, "备案注销" },
            { 2, "备案存续" }
        };

        public static readonly Dictionary<int, string> CompanyType = new Dictionary<int, string>
        {
            { 0, "未知" },
            { 1, "私募证券投资" },
            { 2, "公募基金公司" },
            { 3, "银行" },
            { 4, "证券公司" },
            { 5, "信托公司" },
            { 6, "审计机构" },
            { 7, "法律顾问" },
            { 8, "投资顾问" },
            { 9, "行政管理人" },
            { 10, "上市公司" },
            { 11, "期货公司" },
            { 12, "基金子公司" },
            { 13, "工作室" },
            { 14, "私募股权投资" },
            { 15, "证券子公司" },
            { 16, "期货子公司" },
            { 17, "私募创业投资" },
            { 18, "私募其他投资" },
            { 19, "保险公司" },
            { 20, "保险子公司" },
            { 21, "私募资产配置类" },
            { 22, "证券公司私募子公司" },
            { 23, "独立第三方销售机构" },
            { 24, "支付结算机构" },
            { 25, "独立服务机构" },
            { 26, "地方自律组织" },
            { -1, "未知" }

        };

        public static readonly Dictionary<int, string> FundType = new Dictionary<int, string>
        {
            { 1, "信托计划" },
            { 2, "有限合伙" },
            { 3, "券商资管" },
            { 4, "公募专户" },
            { 5, "单账户" },
            { 6, "证券投资基金" },
            { 7, "海外基金" },
            { 8, "期货资管" },
            { 9, "保险资管" },
            { 10, "创业投资基金" },
            { 11, "股权投资基金" },
            { 12, "银行理财" },
            { 13, "类固收信托" },
            { 14, "私募资产配置基金" },
            { 15, "公募基金" },
            { 16, "公募投顾" },
            { -1, "其他投资基金" }

        };

        public static readonly Dictionary<int, string> ManagerType = new Dictionary<int, string>
        {
            { 1, "顾问管理" },
            { 2, "受托管理" },
            { 3, "自我管理" }
        };

        public static readonly Dictionary<int, string> Currency = new Dictionary<int, string>
        {
            { 1, "人民币" },
            { 2, "港币" },
            { 3, "美元" }
        };

        public static readonly Dictionary<int, string> RaiseType = new Dictionary<int, string>
        {
            { 1, "私募" },
            { 2, "公募" }
        };

        public static readonly Dictionary<int, string> FundStatus = new Dictionary<int, string>
        {
            { 1, "募集中" },
            { 2, "开放运行" },
            { 3, "封闭运行" },
            { 4, "提前清算" },
            { 5, "到期清算" },
            { 6, "发行失败" },
            { 7, "更换管理人" },
            { 8, "延期清算" },
            { -1, "其他" }

        };

        public static readonly Dictionary<int, string> HedgeFundStrategy = new Dictionary<int, string>
        {
            { 1, "股票策略" },
            { 2, "宏观策略" },
            { 3, "管理期货" },
            { 4, "事件驱动" },
            { 5, "相对价值" },
            { 6, "固定收益" },
            { 7, "组合基金" },
            { 8, "复合策略" },
            { -1, "其他" }
        };

        public static readonly Dictionary<int, string> MutualFundStrategy = new Dictionary<int, string>
        {
            { 101, "股票" },
            { 102, "混合" },
            { 103, "债券" },
            { 104, "货币" },
            { 105, "商品" },
            { -100, "其他" }
        };
    }
}
